/*
 * Mp3Encoder.cpp
 *
 *  Created on: Nov 7, 2019
 *      Author: elchaschab
 */

#include "Mp3Encoder.hpp"

#include <limits>
#include <cassert>
#include <iostream>

namespace midipatch {

Mp3Encoder::Mp3Encoder(size_t sampleRate) :
		lame(lame_init()) {
	lame_set_in_samplerate(lame, sampleRate);
	lame_set_VBR(lame, vbr_default);
	lame_init_params(lame);
}

Mp3Encoder::~Mp3Encoder() {
}

size_t Mp3Encoder::encode(const std::vector<float>& pcm) {
	if (pcm.empty())
		return 0;

	for (size_t i = 0; i < pcm.size(); ++i) {
		assert(pcm[i] >= -1.0 && pcm[i] <= 1.0);
		pcm_buffer[i] = pcm[i] * std::numeric_limits<short int>::max();
	}
	return lame_encode_buffer_interleaved(lame, pcm_buffer, (int) pcm.size(), mp3_buffer, (int) MP3_SIZE);
}

unsigned char* Mp3Encoder::getOutputBuffer() {
	return mp3_buffer;
}

size_t Mp3Encoder::end() {
	return lame_encode_flush(lame, mp3_buffer, MP3_SIZE);
}
} /* namespace midipatch */
