/*
 * Mp3Encoder.hpp
 *
 *  Created on: Nov 7, 2019
 *      Author: elchaschab
 */

#ifndef SRC_MP3ENCODER_HPP_
#define SRC_MP3ENCODER_HPP_

#include <cstddef>
#include <lame/lame.h>
#include <vector>

#define MP3_SIZE 8192

namespace midipatch {

class Mp3Encoder {
	lame_t lame;
	short int pcm_buffer[MP3_SIZE];
	unsigned char mp3_buffer[MP3_SIZE];

public:
	Mp3Encoder(size_t sampleRate);
	virtual ~Mp3Encoder();
	size_t encode(const std::vector<float>& pcm);
	unsigned char* getOutputBuffer();
	size_t end();
};

} /* namespace midipatch */

#endif /* SRC_MP3ENCODER_HPP_ */
